unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Close1: TMenuItem;
    Exit1: TMenuItem;
    Nahlad1: TMenuItem;
    CelaObrazovka1: TMenuItem;
    ZmensiOkno1: TMenuItem;
    Kresli1: TMenuItem;
    Function1: TMenuItem;
    Function2: TMenuItem;
    About1: TMenuItem;
    Help1: TMenuItem;
    Info1: TMenuItem;
    Rovnobezne1: TMenuItem;
    Zoom1: TMenuItem;
    Otoc1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Zvcsi1: TMenuItem;
    Zmensi1: TMenuItem;
    OkoloXovejosy1: TMenuItem;
    OkoloYlonovejosy1: TMenuItem;
    OkoloZovejosy1: TMenuItem;
    Minimalizuj1: TMenuItem;
    Posun1: TMenuItem;
    Vlavo1: TMenuItem;
    Vpravo1: TMenuItem;
    Hore1: TMenuItem;
    Dole1: TMenuItem;
    Dopredu1: TMenuItem;
    Dozadu1: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Function1Click(Sender: TObject);
    procedure Rovnobezne1Click(Sender: TObject);
    procedure Zvcsi1Click(Sender: TObject);
    procedure Zmensi1Click(Sender: TObject);
    procedure OkoloXovejosy1Click(Sender: TObject);
    procedure OkoloYlonovejosy1Click(Sender: TObject);
    procedure OkoloZovejosy1Click(Sender: TObject);
    procedure CelaObrazovka1Click(Sender: TObject);
    procedure ZmensiOkno1Click(Sender: TObject);
    procedure Minimalizuj1Click(Sender: TObject);
    procedure Vlavo1Click(Sender: TObject);
    procedure Vpravo1Click(Sender: TObject);
    procedure Hore1Click(Sender: TObject);
    procedure Dole1Click(Sender: TObject);
    procedure Dopredu1Click(Sender: TObject);
    procedure Dozadu1Click(Sender: TObject);
  private
    sur: Array [1..8,1..3]of Real;
    sura: Array [1..8,1..3] of Real;
     w1,w2,w3,kk,ff: Integer;
     d1,d2,d3,stredx, stredy, stredz: Real;
     tr,ts: Real;
    procedure KresliStredovo();
    procedure KresliRovnobezne();
    procedure Usecka(a,b: Integer);
    procedure Strana(b1,b2,b3,b4,b5: Integer);
    procedure Vymaz();
    procedure Zoom(a,b:Integer);
    procedure Posun(x,y,z:Real);
    procedure Otocz();
    procedure Otocx();
    procedure Otocy();
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}



procedure TForm1.FormCreate(Sender: TObject);
begin
sur[1,1]:=50;
sur[1,2]:=50;
sur[1,3]:=0;
sur[2,1]:=50;
sur[2,2]:=100;
sur[2,3]:=0;
sur[3,1]:=100;
sur[3,2]:=100;
sur[3,3]:=0;
sur[4,1]:=100;
sur[4,2]:=50;
sur[4,3]:=0;
sur[5,1]:=50;
sur[5,2]:=50;
sur[5,3]:=50;
sur[6,1]:=50;
sur[6,2]:=100;
sur[6,3]:=50;
sur[7,1]:=100;
sur[7,2]:=100;
sur[7,3]:=50;
sur[8,1]:=100;
sur[8,2]:=50;
sur[8,3]:=50;
stredx:=75;
stredy:=75;
stredz:=25;
d1:=75;
d2:=75;
d3:=-1000;
w1:=0;
w2:=0;
w3:=100;
ff:=0;

end;




procedure TForm1.Usecka(a,b:Integer);
begin
Canvas.MoveTo(round(sura[a,1]),round(sura[a,2]));
Canvas.LineTo(round(sura[b,1]),round(sura[b,2]));
end;


procedure TForm1.Strana(b1,b2,b3,b4,b5:Integer);
var u0,u1,u2,v1,v2,v0,uv0,uv2,uv1:Integer;
    par,pom1,pom2,pom:Real;
begin;


u0:=round(sur[b1,1])-round(sur[b2,1]);
u1:=round(sur[b1,2])-round(sur[b2,2]);
u2:=round(sur[b1,3])-round(sur[b2,3]);
v0:=round(sur[b3,1])-round(sur[b2,1]);
v1:=round(sur[b3,2])-round(sur[b2,2]);
v2:=round(sur[b3,3])-round(sur[b2,3]);
uv0:=u1*v2-u2*v1;
uv1:=u2*v0-u0*v2;
uv2:=u0*v1-u1*v0;
par:=-uv0*round(sur[b4,1])-uv1*round(sur[b4,2])-uv2*round(sur[b4,3]);
pom1:=uv0*round(stredx)+uv1*round(stredy)+uv2*round(stredz)+par;
pom2:=uv0*round(d1)+uv1*round(d2)+uv2*round(d3)+par;
pom:=pom1*pom2;

if pom<0 then begin

Usecka(b1,b2);
Usecka(b2,b3);
Usecka(b3,b4);
Usecka(b1,b4);
             end;


end;

procedure TForm1.KresliStredovo();
var i:Integer;
begin
Vymaz;
for i:=1 to 8 do begin
ts:=-1*(d3/(d3-sur[i,3]));
sura[i,1]:=d1+(ts*(d1-sur[i,1]));
sura[i,2]:=d2+(ts*(d2-sur[i,2]));
end;
Strana(1,2,3,4,1);
Strana(1,2,6,5,2);
Strana(1,4,8,5,3);
Strana(2,3,7,6,4);
Strana(3,7,8,4,5);
Strana(5,6,7,8,6);
end;



procedure TForm1.KresliRovnobezne();
var i:Integer;

begin
Vymaz();
for i:=1 to 8 do begin
sura[i,3]:=0;
tr:=(-1*(sur[i,3]/w3));
sura[i,1]:=(sur[i,1]+tr*w1);
sura[i,2]:=(sur[i,2]+tr*w2);

end;
Strana(1,2,3,4,1);
Strana(1,2,6,5,2);
Strana(1,4,8,5,3);
Strana(2,3,7,6,4);
Strana(3,7,8,4,5);
Strana(5,6,7,8,6);
end;



 procedure TForm1.Zoom(a,b:Integer);
 var x,y,z,sx,sy,sz:Real;
     i:Integer;
     vektorx, vektory, vektorz: Real;
 begin
 Vymaz();
 for i:=1 to 8 do begin
 x:=(sur[i,1]*a/b);
 y:=(sur[i,2]*a/b);
 z:=(sur[i,3]*a/b);
 sur[i,1]:=x;
 sur[i,2]:=y;
 sur[i,3]:=z;
 end;

 sx:=(stredx*a/b);
 sy:=(stredy*a/b);
 sz:=(stredz*a/b);
 vektorx:=stredx-sx;
 vektory:=stredy-sy;
 vektorz:=stredz-sz;
 Posun(vektorx,vektory,vektorz);

 if kk=1 then
 KresliStredovo();
 if kk=2 then
 KresliRovnobezne();


 end;

procedure TForm1.Posun(x,y,z:Real);
var i:Integer;
begin
for i:=1 to 8 do begin
  sur[i,1]:=x+sur[i,1];
  sur[i,2]:=y+sur[i,2];
  sur[i,3]:=z+sur[i,3];
end;
if ff=1 then  begin stredx:=x+stredx;
                    stredy:=y+stredy;
                    stredz:=z+stredz;
                    d1:=x+d1;
                    d2:=y+d2;
                    d3:=z+d3;
                    ff:=0;
              end;

end;


procedure TForm1.Otocz();
var x,y,sx,sy,sz: Real;
    i:Integer;
    vektorx,vektory,vektorz: Real;

 begin
 Vymaz();
 for i:=1 to 8 do begin
 x:=(sur[i,1]*cos(Pi/16)-sur[i,2]*sin(Pi/16));
 y:=(sur[i,1]*sin(Pi/16)+sur[i,2]*cos(Pi/16));
 sur[i,1]:=x;
 sur[i,2]:=y;
 end;
 sx:=(stredx*cos(Pi/16)-stredy*sin(Pi/16));
 sy:=(stredx*sin(Pi/16)+stredy*cos(Pi/16));
 sz:=stredz;
 vektorx:=stredx-sx;
 vektory:=stredy-sy;
 vektorz:=stredz-sz;
 Posun(vektorx,vektory,vektorz);


if kk=1 then KresliStredovo();
if kk=2 then KresliRovnobezne();

end;


 procedure TForm1.Otocx();
var z,y,sx,sy,sz: Real;
    i:Integer;
    vektorx,vektory,vektorz: Real;

 begin
 Vymaz();
 for i:=1 to 8 do begin
 y:=(sur[i,2]*cos(Pi/16)-sur[i,3]*sin(Pi/16));
 z:=(sur[i,2]*sin(Pi/16)+sur[i,3]*cos(Pi/16));
 sur[i,2]:=y;
 sur[i,3]:=z;
 end;
 sy:=(stredy*cos(Pi/16)-stredz*sin(Pi/16));
 sz:=(stredy*sin(Pi/16)+stredz*cos(Pi/16));
 sx:=stredx;
 vektorx:=stredx-sx;
 vektory:=stredy-sy;
 vektorz:=stredz-sz;
 Posun(vektorx,vektory,vektorz);


if kk=1 then KresliStredovo();
if kk=2 then KresliRovnobezne();

end;



 procedure TForm1.Otocy();
var x,z,sx,sy,sz: Real;
    i:Integer;
    vektorx,vektory,vektorz: Real;

 begin
 Vymaz();
 for i:=1 to 8 do begin
 x:=(sur[i,1]*cos(Pi/16)+sur[i,3]*sin(Pi/16));
 z:=(-sur[i,1]*sin(Pi/16)+sur[i,3]*cos(Pi/16));
 sur[i,1]:=x;
 sur[i,3]:=z;
 end;
 sx:=(stredx*cos(Pi/16)+stredz*sin(Pi/16));
 sz:=(-stredx*sin(Pi/16)+stredz*cos(Pi/16));
 sy:=stredy;
 vektorx:=stredx-sx;
 vektory:=stredy-sy;
 vektorz:=stredz-sz;
 Posun(vektorx,vektory,vektorz);


if kk=1 then KresliStredovo();
if kk=2 then KresliRovnobezne();

end;





procedure TForm1.Vymaz();

begin
Canvas.Pen.Color:=clwhite;
Strana(1,2,3,4,1);
Strana(1,2,6,5,2);
Strana(1,4,8,5,3);
Strana(2,3,7,6,4);
Strana(3,7,8,4,5);
Strana(5,6,7,8,6);
Canvas.Pen.Color:=clred;

end;




procedure TForm1.Rovnobezne1Click(Sender: TObject);
begin
  Vymaz();
  KresliRovnobezne();
  kk:=2;
end;



procedure TForm1.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.Function1Click(Sender: TObject);
begin
 vymaz();
 KresliStredovo();
 kk:=1;
end;



procedure TForm1.Zvcsi1Click(Sender: TObject);
begin
 Zoom(12,10);
end;

procedure TForm1.Zmensi1Click(Sender: TObject);
begin
Zoom(8,10);
end;

procedure TForm1.OkoloXovejosy1Click(Sender: TObject);
begin
Otocx();
end;

procedure TForm1.OkoloYlonovejosy1Click(Sender: TObject);
begin
Otocy();
end;

procedure TForm1.OkoloZovejosy1Click(Sender: TObject);
begin
Otocz();
end;

procedure TForm1.CelaObrazovka1Click(Sender: TObject);
begin
Form1.WindowState:=wsMaximized;
end;

procedure TForm1.ZmensiOkno1Click(Sender: TObject);
begin
Form1.WindowState:=wsNormal;
end;

procedure TForm1.Minimalizuj1Click(Sender: TObject);
begin
Form1.WindowState:=wsMinimized;
end;

procedure TForm1.Vlavo1Click(Sender: TObject);
begin
ff:=1;
Posun(-10,0,0);
If kk=1 then KresliStredovo;
If kk=2 then KresliRovnobezne;
end;

procedure TForm1.Vpravo1Click(Sender: TObject);
begin
ff:=1;
Posun(10,0,0);
If kk=1 then KresliStredovo;
If kk=2 then KresliRovnobezne;
end;

procedure TForm1.Hore1Click(Sender: TObject);
begin
ff:=1;
Posun(0,-10,0);
If kk=1 then KresliStredovo;
If kk=2 then KresliRovnobezne;
end;

procedure TForm1.Dole1Click(Sender: TObject);
begin
ff:=1;
Posun(0,10,0);
If kk=1 then KresliStredovo;
If kk=2 then KresliRovnobezne;
end;

procedure TForm1.Dopredu1Click(Sender: TObject);
begin
ff:=1;
Posun(0,0,10);
If kk=1 then KresliStredovo;
If kk=2 then KresliRovnobezne;
end;

procedure TForm1.Dozadu1Click(Sender: TObject);
begin
ff:=1;
Posun(0,0,-10);
If kk=1 then KresliStredovo;
If kk=2 then KresliRovnobezne;
end;

end.
